﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _08_1_Exceptions1
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void button1_Click(object sender, EventArgs e)
    {
      int a = 0;
      int b = 0;
      int c, k;

      if (int.TryParse(textBox1.Text, out k))
        a = k;
      else
      {
        MessageBox.Show("Źle wpisałeś A!");
        return;
      }

      if (int.TryParse(textBox2.Text, out k))
        b = k;
      else
      {
        MessageBox.Show("Źle wpisałeś B!");
        return;
      }

      if (b == 0)
      {
        MessageBox.Show("Dzielenie przez zero!");
        return;
      }
      {
        c = a / b;
        label1.Text = $"c = a/b = {c}";
      }

    }

    private void button2_Click(object sender, EventArgs e)
    {
      try
      {
        int a = int.Parse(textBox1.Text);
        int b = int.Parse(textBox2.Text);
        int c = a / b;
        label1.Text = $"c = a/b = {c}";
      }
      catch
      {
        MessageBox.Show("Błąd!");
      }
    }

    private void button3_Click(object sender, EventArgs e)
    {
      try
      {
        int a = int.Parse(textBox1.Text);
        int b = int.Parse(textBox2.Text);
        int c = a / b;
        label1.Text = $"c = a/b = {c}";
      }
      catch (Exception exc)
      {
        MessageBox.Show($"Błąd!\r\n{exc.Message}\r\n{exc.StackTrace}");
      }
    }

    private void button4_Click(object sender, EventArgs e)
    {
      try
      {
        int a = int.Parse(textBox1.Text);
        int b = int.Parse(textBox2.Text);
        int c = a / b;
        label1.Text = $"c = a/b = {c}";
      }
      catch (FormatException exc)
      {
        MessageBox.Show($"Błąd - zły format danych!\r\n{exc.Message}\r\n{exc.StackTrace}");
      }
      catch (DivideByZeroException exc)
      {
        MessageBox.Show($"Błąd - dzielenie przez zero!\r\n{exc.Message}\r\n{exc.StackTrace}");
      }
      catch (Exception exc)
      {
        MessageBox.Show($"Błąd - bliżej nieokreślony!\r\n{exc.Message}\r\n{exc.StackTrace}");
      }
    }

    private void button5_Click(object sender, EventArgs e)
    {
      try
      {
        int a = int.Parse(textBox1.Text);
        int b = int.Parse(textBox2.Text);
        int c = a / b;
        label1.Text = $"c = a/b = {c}";
      }
      catch (Exception exc)
      {
        MessageBox.Show($"Błąd - bliżej nieokreślony!\r\n{exc.Message}\r\n{exc.StackTrace}");
      }
      finally
      {
        MessageBox.Show("Koniec próby obliczenia czegoś");
      }
    }

    private void button6_Click(object sender, EventArgs e)
    {
      int a = 0;
      int b = 0;
      int c;
      try
      {
        try
        {
          a = int.Parse(textBox1.Text);
        }
        catch(Exception exc) 
        {
          MessageBox.Show($"Źle podano A!\r\n{exc.Message}");
          throw exc;
        }
        try
        {
          b = int.Parse(textBox2.Text);
        }
        catch (Exception exc)
        {
          MessageBox.Show($"Źle podano B!\r\n{exc.Message}");
          throw exc;
        }
        try
        {
          c = a / b;
          label1.Text = $"c = a/b = {c}";         
        }
        catch (Exception exc)
        {
          MessageBox.Show($"Nie da sie policzyć!\r\n{exc.Message}");
          throw exc;
        }
      }
      catch (Exception exc)
      {
        MessageBox.Show($"Błąd - bliżej nieokreślony!\r\n{exc.Message}\r\n{exc.StackTrace}");
      }
      finally
      {
        MessageBox.Show("Koniec próby obliczenia czegoś");
      }
    }

    int dziel(int a, int b)
    {
      int c = 0;
      try
      {
        c = a / b;        
      }
      catch (Exception exc)
      {
        Exception exc2 = new Exception("Błąd wewnętrzny w p funkcji dziel()!", exc);
        throw exc2; 
      }
      return c;
    }

    private void button7_Click(object sender, EventArgs e)
    {
      try
      {
        int a = int.Parse(textBox1.Text);
        int b = int.Parse(textBox2.Text);
        int c = dziel(a, b);
        label1.Text = $"c = a/b = {c}";
      }
      catch (Exception exc)
      {
        MessageBox.Show($"Błąd - bliżej nieokreślony!\r\n{exc.Message}\r\n{exc.StackTrace}");
        if (exc.InnerException != null)
          MessageBox.Show($"Oryginaly błąd: {exc.InnerException.Message}");
      }

    }
  }
}
